package sillysagiri;

import javax.microedition.lcdui.Graphics;

public class Sagiri 
{
  public static final int KEY_NONE = -3422;

  public static final int KEY_UP = -1;
  public static final int KEY_DOWN = -2;
  public static final int KEY_LEFT = -3;
  public static final int KEY_RIGHT = -4;

  public static final int KEY_0 = 48;
  public static final int KEY_1 = 49;
  public static final int KEY_2 = 50;
  public static final int KEY_3 = 51;
  public static final int KEY_4 = 52;
  public static final int KEY_5 = 53;
  public static final int KEY_6 = 54;
  public static final int KEY_7 = 55;
  public static final int KEY_8 = 56;
  public static final int KEY_9 = 57;

  public static final int KEY_STAR = 42;
  public static final int KEY_POUND = 35;

  public static final int KEY_CENTER = -5;

  public static final int[] KEY_LEFT_SOFT = { -6, -202, -21, 21, -11, 105, -20};
  public static final int[] KEY_RIGHT_SOFT = {-7, -203, -22, 22,      106, -21};
  
  public final static int TOUCH_NONE = 0;
  public final static int TOUCH_BEGIN = 1;
  public final static int TOUCH_END = 2;
  public final static int TOUCH_DRAG = 3;

  public static Sagiri _instance = null;

  public Input input;

  public int fps = 60;

  private Scene _scene_current = null;
  public long time_begin = 0;
  public long time_delta = 0;

  public Sagiri()
  {
    _instance = this;
    input = new Input();
  }

  public void Update(Graphics g)
  {
    if (_scene_current != null)
    {
      
      while (!_scene_current.preloaded)
      {
        _scene_current.preloaded = true;
        _scene_current.Preload();
      }

      _scene_current.Update(time_delta, g);
    }
  }

  public Scene Get_Scene() { return _scene_current; }
  public void Set_Scene(Scene scene)
  {
    if (_scene_current != null)
    {
      _scene_current.Destroy();
      _scene_current = null;
      System.gc();
    }
    _scene_current = scene;
  }

  public final long GetFrameTime() { return time_delta; }
}
